/**
 * 
 */
package evaHelper;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.Hashtable;
import java.util.StringTokenizer;
import java.util.Vector;

/**
 * @author Florence
 *
 */
public class EvaGraphML {

	//XML File Headers
	private static String	XMLHeader = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
	private static String	GRAPHML_HEADING = "<graphml xmlns=\"http://graphml.graphdrawing.org/xmlns\">";
	private static String	GRAPHML_ENDING	= "</graphml>";

	//NOTE TO ME!!! i think it's case sensitive (Prefuse) :( doof!	
	
	//DATA/EDGE SCHEMA
	//e.g <key id="src" for="node" attr.name="src" attr.type="string"/>
	private static String	TAG_KEY			= "key";
	private static String	ATTR_ID			= "id";
	private static String	ATTR_FOR 		= "for";
	private static String	ATTR_NAME 	= "attr.name";
	private static String	ATTR_TYPE 	= "attr.type";
	
	private static String	VALUE_NODE 	= "node";	
	private static String	VALUE_STRING = "string";
	
	private static String	VALUE_EDGE 	= "edge";
	private static String	VALUE_INT 		= "integer";
		
	
	//GRAPH
	//e.g <graph id="G" edgedefault="undirected">
	private static String	TAG_GRAPH 			= "graph";
	private static String	ATTR_EDGEDEFAULT	= "edgedefault";
	private static String	VALUE_UNDIRECTED	= "undirected";
	private static String	VALUE_DIRECTED		= "directed";
	
	//NODES
	//e.g.	
	//	<node id="1">
	//		<data key="src"> </data>
	//		<data key="gender"> </data>
	//	</node>
	private static String	TAG_NODE	= "node";
	private static String	TAG_DATA	= "data";

	//EDGE
	//e.g. <edge id="e1" directed="true" source="n0" target="n2"/>
	private static String	TAG_EDGE			= "edge";
	private static String	ATTR_DIRECTED	= "directed";
	private static String	ATTR_SOURCE		= "source";
	private static String	ATTR_TARGET		= "target";
	private static String	VALUE_TRUE		= "true";
	private static String	VALUE_FALSE		= "false";
	
	//Others
	private static String 		DELIMITER = ",";

	//EVALOGGER SPECIFIC TAGS
	private static String	EVA_SCREEN 		= "screen";
	private static String	EVA_UNIQUE_ID 	= ATTR_ID;	
	private static String	EVA_COMPONAME = "compoName";
	private static String	EVA_COMPOTYPE 	= "compoType";
	private static String	EVA_ACTION 		= "compoAction";
	private static String	EVA_LOGTIME 		= "logTime";
	private static String	EVA_DURATION_MSECS 	= "durationInMillisecs";
	
	//OUTPUT FORMATS------------------------------------------------
	//YED Specific
	public static String GraphMLExt = ".graphml";
	private static boolean outputYED = true;
	private static String	GRAPHML_HEADING_YED = 
			"<graphml xmlns=\"http://graphml.graphdrawing.org/xmlns\" \n" 		+
				"xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" \n"  	+
				"xmlns:y=\"http://www.yworks.com/xml/graphml\" \n" 			+
				"xsi:schemaLocation=\"http://graphml.graphdrawing.org/xmlns/graphml http://www.yworks.com/xml/schema/graphml/1.0/ygraphml.xsd\">";
	
	/* Additional Data
	  <key id="d1" 	for ="node" yfiles.type="nodegraphics" />
	  <key id="d2"	for ="node" attr.name="description" attr.type="string" />
	  
	  <key id="d3"	for="edge" yfiles.type="edgegraphics" />
	  <key id="d4"	for ="edge" attr.name="description" attr.type="string" />  
	 */
	private static String	YFILE_TYPE			= "yfiles.type";
	private static String	YFILE_NODEGRAPHICS	= "nodegraphics";	
	private static String	YFILE_EDGEGRAPHICS  = "edgegraphics";

	private static String	YFILE_ID_NODEGRAPHICS	= "d0";//"nodegraphics";	
	private static String	YFILE_ID_EDGEGRAPHICS  = "d2";//"edgegraphics";

	
	private static String	YFILE_ID_NODE_DECR = "d1";//"nodedescription";
	private static String	YFILE_ID_EDGE_DECR = "d3";//"edgedescription";
	private static String	YFILE_ATTR_DECR = "description";
	
	private static int		WIDTH  = 100;
	private static int		HEIGHT = 20;
	//--------------------------------------------------------------
	private StringBuffer						strBuffer = null;
	private Vector<EvaScreenVector>	graphsVector; 		//Where the vector of "Screens(with the corresponding nodes) are stored"
	private EvaEdgeVector					edgesVector;		//where the edges are stored


	/////------------------YED SPECIFIC SCHEMA------------------------------
	
	/**
	/* Additional Data
	  <key id="nodegraphics" 	for ="node" yfiles.type="nodegraphics" />
	  <key id="nodedescription"	for ="node" attr.name="description" attr.type="string" />
	  
	  <key id="edgegraphics" for="edge" yfiles.type="edgegraphics" />
	  <key id="edgedescription"	 for ="edge" attr.name="description" attr.type="string" />  
	 
	
		private static String	YFILE_TYPE			= "yfiles.type";
		private static String	YFILE_NODEGRAPHICS	= "nodegraphics";	
		private static String	YFILE_EDGEGRAPHICS  = "edgegraphics";
		
		private static String	YFILE_ID_NODE_DECR = "nodedescription";
		private static String	YFILE_ID_EDGE_DECR = "edgedescription";
		
	 */
	private void initializeForYED(){
		GRAPHML_HEADING = GRAPHML_HEADING_YED;
		
	}
	
	private void createYedSpecificSchema(){
		addToStringBuffer("<!-- YED Specific schema -->");
		
		//node
		addToStringBuffer(getYEDDataOrNodeSchemaXMLStr(YFILE_ID_NODEGRAPHICS,VALUE_NODE,null,YFILE_NODEGRAPHICS));
		addToStringBuffer(getDataOrNodeSchemaXMLStr(YFILE_ID_NODE_DECR,VALUE_NODE,YFILE_ATTR_DECR,VALUE_STRING));
		
		//edge
		addToStringBuffer(getYEDDataOrNodeSchemaXMLStr(YFILE_ID_EDGEGRAPHICS,VALUE_EDGE,null,YFILE_EDGEGRAPHICS));
		addToStringBuffer(getDataOrNodeSchemaXMLStr(YFILE_ID_EDGE_DECR,VALUE_EDGE,YFILE_ATTR_DECR,VALUE_STRING));

	}
	
	private String getYEDDataOrNodeSchemaXMLStr( String id, String forWhich, String name, String type ){
		
		String temp = 	"<" + TAG_KEY + " " +
							ATTR_ID + "=\"" + id	+"\" " +
							ATTR_FOR + "=\"" + forWhich	+"\" ";
		if( name != null ){
			temp +=		ATTR_NAME + "=\"" + name	+"\" ";
		}
		
		temp+=		YFILE_TYPE + "=\"" + type	+"\" " +
						"/>";
		
		//FTBDebug(temp);
		
		return temp;
	}
	
	private void addYEDToStrBufferNodesXMLStr(String compoName, String compoType){
		
		String theData ="<y:ShapeNode>\n" +
						"<y:Geometry height=\"" + HEIGHT + "\" width=\"" + WIDTH + "\"/>" +
							"<y:NodeLabel alignment=\"center\" \n" +
									"autoSizePolicy=\"content\" \n"+
									"fontFamily=\"Dialog\" fontSize=\"12\" fontStyle=\"plain\" \n" +
									"hasBackgroundColor=\"false\" hasLineColor=\"false\" \n" + 
									"modelPosition=\"c\" textColor=\"#000000\" visible=\"true\" \n" +
									">" + compoName + "</y:NodeLabel>\n" +
							"<y:Shape type=\"rectangle\"/>\n" +
							"</y:ShapeNode>";
	
			
		addToStringBuffer(getDataTagXMLStr( YFILE_ID_NODEGRAPHICS, theData));		
		addToStringBuffer(getDataTagXMLStr( YFILE_ID_NODE_DECR, compoName)); //may gamit ba to?

		}
	
	//------------------PUBLIC METHODS--------------------------
	/**
	 * Screen -> graphsVector
	 * Log in one line -> items in the vector
	 */
	public EvaGraphML(String csvFile) {
		
		strBuffer 		= new StringBuffer();
		graphsVector 	= new Vector<EvaScreenVector>();
		edgesVector	= new EvaEdgeVector();

		if(outputYED){
			initializeForYED();
		}
		
		//START GRAPH
		addToStringBuffer(XMLHeader);		

		addToStringBuffer(GRAPHML_HEADING);		
		
		//note: this goes before the graph tag
		if( outputYED ){
			createYedSpecificSchema();
		}
		
		addToStringBuffer(getGraphsXMLStr(null , true));		
		
		//CREATE DATA and EDGE SCHEMA -> what are the node keys
		createDataSchema();
		createEdgeSchema();
		
		//////////////
		//Process the file first and store information to local 
		try{
		
			BufferedReader csvReader = new BufferedReader( new FileReader( csvFile ));
			
			String curLine = null;
			while ((curLine = csvReader.readLine()) != null){
				
				processCSVString(curLine);
				
			} // end while
		}
		catch( Exception e ){
			FTBDebug("EvaGraphML :"+e);
		}
		
		//start creating the nodes and edges
		createGraphMLGraphsNodes();		
		createGraphMLGraphsEdges();
		
		//TODO later: add edge to signify end
		
		//////////////
		//END GRAPH
		addToStringBuffer(getGraphsXMLStrEndTag());
		addToStringBuffer(GRAPHML_ENDING);
		
		//////////////
		//FTBDebug(strBuffer.toString());
	}
	
	/**
	 * 	 @return the graphml into string form
	 */
	public String getCreatedGraphMLString(){
		return strBuffer.toString();
	}
	
	//--------------------GENERAL PURPOSE---------------------------
	/**
	 * Adds a string to the private variable strBuffer. This is the variable
	 * that is used to store the whole graphml strings
	 * @param str
	 */
	private void addToStringBuffer(String str){
		strBuffer.append(str + "\n");
	}
	
	/**
		ONE graphsVector contains a vector of EvaScreenVector
	  	EACH EvaScreenVector contains a HashTable that contains all the NODES that exists in the ScreenVector
	  	
	 * token 1 -> screen -> vector
	 * token 2 -> compo name
	 * token 3 -> compo type
	 * token 4 -> action
	 * token 5 -> logtime
	 * @param curLine
	 */
	//vars for edge processing, we need to put this in this
	// level since we need it for every iteration
	static boolean 			firstNode = true;
	static String			source 	= null;
	static String			dest 		= null;
	static String			edgeAction = null;
	static String			fromTime 	= null;	//(duration = toTime - fromTime)
	static String			toTime 		= null;

    //screen specific processing
    static String           curScreen = null;
    
	private void processCSVString(String curLine){
		
		StringTokenizer tokenList = new StringTokenizer(curLine, DELIMITER);
				
		try{
			String screen 		= tokenList.nextToken();
			String compoName= tokenList.nextToken();
			String compoType= tokenList.nextToken();
			String action		= tokenList.nextToken();
			String logtime		= tokenList.nextToken();
						
			//look if screen already has it's own vector			
			boolean exists = false;
			
			for(int i=0; i<graphsVector.size(); i++){
			
				EvaScreenVector evaVector = graphsVector.get(i);
				
				if (evaVector.getId().equals(screen)){	
					evaVector.addNode(screen, compoName, compoType, action, logtime);
					exists = true;
					break;
				}
				
			}
			
			//if does not exist, make a new one and add to graphsVector
			if( !exists ){
				EvaScreenVector evaNewVector = new EvaScreenVector( screen );
				evaNewVector.addNode(screen, compoName, compoType, action, logtime);
				graphsVector.add(evaNewVector);
			}
			
			//process edges
			if( firstNode ){
				source	= (new EvaScreenVector("temporary")).makeID(screen, compoName, compoType);
				//dest 		= null; 		//unknown for this time
				edgeAction 	= action; 	//this is the action that triggered this move
				fromTime= logtime;		//(duration = toTime - fromTime)
				//toTime 	= null;		//unknown for this time
				
				firstNode = false;

                //screen specific processing
                curScreen = screen;
			}
			else{
				
				toTime = logtime;

                boolean curScreenEqual = true;
                //TODO check here if it's no longer in the same screen, point to the next screen
                if( curScreen.equals(screen) ){
                    dest = (new EvaScreenVector("temporary")).makeID(screen, compoName, compoType);     
                }
                else{
                    dest = screen;
                    curScreen = screen;
                    curScreenEqual = false;
                }

				//create edge
				edgesVector.addEdge(source, dest, action, fromTime, toTime );
				
				//initialize for next iteration
                if( curScreenEqual ){
                    source	= dest;
                }
                else{
                    source = (new EvaScreenVector("temporary")).makeID(screen, compoName, compoType); 
                }
                
				dest 		= null; 		
				edgeAction 	= action;
				fromTime= toTime;	
				toTime 	= null;		
				
			}
		}
		catch( Exception e ){
			FTBDebug("processCSVString =" + e);
		}
	}
	
	
	////////////////////////////START GRAPHML PROCESSING///////////////
	//////------------------GRAPH EDGES TAGS------------------------------
	/**
	 * After processing the file, add the information to strBuffer
	 */
	private void createGraphMLGraphsEdges(){
		
		addToStringBuffer("<!--- Add Edges -->");
		
		//The graphsVector contains a vector of EvaScreenVector
		for(int i=0; i<edgesVector.size(); i++){
														
			Hashtable tempTable = (Hashtable)edgesVector.get(i);
			
			addToStrBufferEdgeXMLStr(tempTable);
						
		}//for graphsVector		
	}		
			
	/**
	 * 		edgeTable.put(EvaGraphML.ATTR_ID, uniqueID);
			
			edgeTable.put(EvaGraphML.ATTR_SOURCE, source);
			edgeTable.put(EvaGraphML.ATTR_TARGET, dest );			
			edgeTable.put(EvaGraphML.EVA_ACTION, action);
			edgeTable.put(EvaGraphML.EVA_DURATION_MSECS, getTimeDurationInMsecs(fromTime, toTime));
	 * @param table
	 */
    private static int edgeCount = 1;

	private void addToStrBufferEdgeXMLStr(Hashtable<String, String> table){		
	
		String id 		= table.get(ATTR_ID);
		String source	= table.get(ATTR_SOURCE);
		String target	= table.get(ATTR_TARGET);
		String action	= table.get(EVA_ACTION);
		String duration	= table.get(EVA_DURATION_MSECS);		
		
		addToStringBuffer(getEdgeTagXMLStr( id, source, target));
		
		//add yed specific data
		if( outputYED ){
	
			String theLabel = edgeCount++ +". (" + action +")\n" + duration + " msecs";
			String theData =
				"<y:PolyLineEdge>\n" +
					"<y:LineStyle color=\"#000000\" type=\"line\" width=\"1.0\"/>\n" +
					"<y:Arrows source=\"none\" target=\"delta\"/>" +
					"<y:EdgeLabel alignment=\"center\" distance=\"2.0\" fontFamily=\"Dialog\" \n" +
						"fontSize=\"10\" fontStyle=\"plain\" hasBackgroundColor=\"false\" \n"+
						"hasLineColor=\"false\" modelName=\"six_pos\" modelPosition=\"tail\" \n" +
						"preferredPlacement=\"anywhere\" ratio=\"0.5\" textColor=\"#000000\" visible=\"true\" \n" +
						">" + theLabel +
						"</y:EdgeLabel>" +
				"</y:PolyLineEdge>\n";

			
			addToStringBuffer(getDataTagXMLStr( YFILE_ID_EDGEGRAPHICS, theData));
		}
		
		addToStringBuffer(getDataTagXMLStr( EVA_ACTION, action));
		addToStringBuffer(getDataTagXMLStr( EVA_DURATION_MSECS, duration));
				
		addToStringBuffer(getEdgeTagXMLStrEnd());
	
	}
	
	/**
	* example: <node id="8">
	* @param id
	* @return
	*/
	private String getEdgeTagXMLStr(String id, String source, String target){
		String temp =  "<"+ 	TAG_EDGE 	+ " " + 
									ATTR_ID 	+ "=\"" + id + "\" " +
									ATTR_SOURCE 	+ "=\"" + source + "\" " +
									ATTR_TARGET 	+ "=\"" + target + "\">";
							
		return temp;
	}
	
	/**
	* example: </node>
	* @return
	*/
	private String getEdgeTagXMLStrEnd(){
	return ("</" + TAG_EDGE +">");
	}
	//////------------------GRAPH NODES TAGS------------------------------
	/**
	 * After processing the file, add the information to strBuffer
	 */
	private void createGraphMLGraphsNodes(){
		
		addToStringBuffer("<!--- Add Nodes -->");		
		
		//The graphsVector contains a vector of EvaScreenVector
		for(int i=0; i<graphsVector.size(); i++){

			
			EvaScreenVector logVector = graphsVector.get(i);
			addToStringBuffer(getSubGraphsXMLStr(logVector.getId(), true));					
						
			//Each EvaScreenVector contains a vector of nodes  (screen->graph)
			for( int j=0; j<logVector.size(); j++ ){ 
															
				Hashtable tempTable = logVector.getNodeTable(j);				
				
				//create nodes for each graph
				addToStrBufferNodesXMLStr(tempTable);
				 
			}//for logVector
			
			addToStringBuffer(getSubGraphsXMLStrEndTag());
		}//for graphsVector
		
	}


	/**
	  	EXAMPLE OUTPUT:
	 		<GRAPH ID=".App" EDGEDEFAULT="directed" >

	 	
	 	USES THE FF CONSTANTS:
	  		public static String	TAG_GRAPH 		= "GRAPH";
			public static String	ATTR_EDGEDEFAULT= "EDGEDEFAULT";
			public static String	VALUE_UNDIRECTED= "undirected";
			public static String	VALUE_DIRECTED	= "directed";
			
	 * @param graphId
	 * @param isDirected true or false
	 * @return
	 */
	private String getGraphsXMLStr(String graphId, boolean isDirected){
		
		String temp = "";
		
		if( graphId != null ){
			temp = "<" + TAG_GRAPH + " " +
							ATTR_ID + "=\"" + graphId +"\" " +
							ATTR_EDGEDEFAULT + "=\"" + (isDirected?VALUE_DIRECTED:VALUE_UNDIRECTED) + "\" " +
							">";
		}
		else{
			temp = "<" + TAG_GRAPH + " " +			
				ATTR_EDGEDEFAULT + "=\"" + (isDirected?VALUE_DIRECTED:VALUE_UNDIRECTED) + "\" " +
				">";
		}
		
		return temp;
	}
	
	private String getGraphsXMLStrEndTag(){
		return ("</" + TAG_GRAPH +">");
	}
	/**
	 * 
	 * @param graphId
	 * @param isDirected
	 * @return
	 */
	private String getSubGraphsXMLStr(String graphId, boolean isDirected){
		
		String temp = "";
		
		if( outputYED )//i know this is lazy: fix later if needed
		{
			
			temp = "<" + TAG_NODE + " " + ATTR_ID + "=\"" + graphId +"\" yfiles.foldertype=\"group\">\n"; //<node id="xxx">			
			
			String theData ="<y:ShapeNode>\n" +
			"<y:NodeLabel " +
					"alignment=\"center\" " +
					"autoSizePolicy=\"content\" "+
					"fontFamily=\"Tahoma\" " +
					"fontSize=\"12\" " +
					"fontStyle=\"plain\" " +
					"hasBackgroundColor=\"false\" " +
					//" lineColor=\"#000000\" \n" + 
					"modelPosition=\"tl\" " +
					"textColor=\"#000000\" " +
					//"rotationAngle=\"270.0\" " +
					"visible=\"true\" \n" +
					">" + graphId + "</y:NodeLabel>\n" +
			"<y:Shape type=\"rectangle\"/>\n" +
			"</y:ShapeNode>";

			
			temp += getDataTagXMLStr( YFILE_ID_NODEGRAPHICS, theData);
			/*
			 <node id="n3" yfiles.foldertype="group">
      <data key="d0">
        <y:ShapeNode>
          <y:Geometry height="77.92000000000007" width="100.98828125" x="137.2897190241229" y="1100.0"/>
          <y:Fill color="#CCCCFF" transparent="false"/>
          <y:BorderStyle color="#000000" type="line" width="1.0"/>
          <y:NodeLabel alignment="center" autoSizePolicy="content" fontFamily="Dialog" fontSize="12" fontStyle="plain" hasBackgroundColor="false" hasLineColor="false" height="18.1328125" modelName="internal" modelPosition="c" textColor="#000000" visible="true" width="90.98828125" x="5.0" y="29.893593750000036">This is a group</y:NodeLabel>
          <y:Shape type="rectangle"/>
        </y:ShapeNode>
      </data>
      <data key="d1"/>
			 */
		}
		else{
			temp = "<" + TAG_NODE + " " + ATTR_ID + "=\"" + graphId +"\">\n"; //<node id="xxx">			
		}
		
		if( graphId != null ){
			temp +=	"<" + TAG_GRAPH + " " +
							ATTR_ID + "=\"" + graphId +"\" " +
							ATTR_EDGEDEFAULT + "=\"" + (isDirected?VALUE_DIRECTED:VALUE_UNDIRECTED) + "\"" +
							">";
		}
		else{
			temp += "<" + TAG_GRAPH + " " +			
				ATTR_EDGEDEFAULT + "=\"" + (isDirected?VALUE_DIRECTED:VALUE_UNDIRECTED) + "\"" +
				">";
		}
		
		return temp;
	}
	
	private String getSubGraphsXMLStrEndTag(){
		return ("</" + TAG_GRAPH +">" +"\n</"+ TAG_NODE+">");
	}
	
	//////------------------NODE TAGS------------------------------
	
	/**
	  		FROM DATA in processCSVString(..):
		  		logValues.put(EVA_UNIQUE_ID, uniqueID);
				logValues.put(EvaGraphML.EVA_COMPONAME, compoName);
				logValues.put(EvaGraphML.EVA_COMPOTYPE, compoType );			
				logValues.put(EvaGraphML.EVA_ACTION, action);
				logValues.put(EvaGraphML.EVA_LOGTIME
			
			EXAMPLE OUTPUT:
		 		<NODE ID="AppnewDroid1222351238862327920">
				<DATA KEY="compoName">newDroid</DATA>
				<DATA KEY="compoType">Button</DATA>
				<DATA KEY="compoAction">onClick</DATA>
				<DATA KEY="logTime">12:22:35</DATA>
				</NODE>
		 	
	 		USES THE FF CONSTANTS:
					private static String	EVA_SCREEN 		= "screen";
					private static String	EVA_UNIQUE_ID 	= "uniqueEvaId";	
					private static String	EVA_COMPONAME = "compoName";
					private static String	EVA_COMPOTYPE 	= "compoType";
					private static String	EVA_ACTION 		= "compoAction";
					private static String	EVA_LOGTIME 		= "logTime";
	 * @param table
	 * @return	 	 
	 */
	private void addToStrBufferNodesXMLStr(Hashtable<String, String> table){		
		
		String id 			= table.get(EVA_UNIQUE_ID);
		String compoName= table.get(EVA_COMPONAME);
		String compoType= table.get(EVA_COMPOTYPE);
		String action		= table.get(EVA_ACTION);
		String logTime		= table.get(EVA_LOGTIME);				
		
		addToStringBuffer(getNodeTagXMLStr(id));	
		
		//add yed specific data
		if( outputYED ){
			addYEDToStrBufferNodesXMLStr(compoName, compoType);
		}
		 
		addToStringBuffer(getDataTagXMLStr( EVA_COMPONAME, compoName));
		addToStringBuffer(getDataTagXMLStr( EVA_COMPOTYPE, compoType));
		addToStringBuffer(getDataTagXMLStr( EVA_ACTION, action));
		addToStringBuffer(getDataTagXMLStr( EVA_LOGTIME, logTime));
		
		addToStringBuffer(getNodeTagXMLStrEnd());
		
	}
	
	/**
	 * example: <node id="8">
	 * @param id
	 * @return
	 */
	private String getNodeTagXMLStr(String id){
		return ("<"+ TAG_NODE + " " + ATTR_ID + "=\"" + id + "\">");
	}
		
	/**
	 * example: </node>
	 * @return
	 */
	private String getNodeTagXMLStrEnd(){
		return ("</" + TAG_NODE +">");
	}
	
	//////------------------DATA TAGS-called in the NODES construction---
	/**
	 * example:<data key="popularity">042</data>
	 * @param key
	 * @param data
	 * @return
	 */
	private String getDataTagXMLStr(String key, String data){
		String temp = 
			"<" + TAG_DATA + " " + TAG_KEY + "=\"" + key + "\">" +
			data +
			"</" + TAG_DATA + ">";
			
		return temp;	
	}

	
	/////------------------DATA SCHEMA------------------------------

	/**
	 * create data schema
	 * 
	 * INFORMATION NEEDED:
		 	private static String	EVA_SCREEN 		= "SCREEN";
			private static String	EVA_UNIQUE_ID 	= "ID";	
			private static String	EVA_COMPONAME = "COMPO_NAME";
			private static String	EVA_COMPOTYPE = "COMPO_TYPE";
			private static String	EVA_ACTION 		= "COMPO_ACTION";
			private static String	EVA_LOGTIME 		= "LOGTIME";
		
		EXAMPLE OUTPUT:	
			<!--- Data Schema for EvaLogger -->
			<KEY ID="screen" FOR="node" ATTR.NAME="screen" ATTR.TYPE="String" />
			<KEY ID="uniqueEvaId" FOR="node" ATTR.NAME="uniqueEvaId" ATTR.TYPE="String" />
			<KEY ID="compoName" FOR="node" ATTR.NAME="compoName" ATTR.TYPE="String" />
			<KEY ID="compoType" FOR="node" ATTR.NAME="compoType" ATTR.TYPE="String" />
			<KEY ID="compoAction" FOR="node" ATTR.NAME="compoAction" ATTR.TYPE="String" />
			<KEY ID="logTime" FOR="node" ATTR.NAME="logTime" ATTR.TYPE="String" />
	 */
	private void createDataSchema(){
		addToStringBuffer("<!--- Data Schema for EvaLogger -->"); 
		
		//addToStringBuffer(getDataOrNodeSchemaXMLStr(EVA_SCREEN, VALUE_NODE, EVA_SCREEN, VALUE_STRING ));
		//addToStringBuffer(getDataOrNodeSchemaXMLStr(EVA_UNIQUE_ID, VALUE_NODE, EVA_UNIQUE_ID, VALUE_STRING ));
		addToStringBuffer(getDataOrNodeSchemaXMLStr(EVA_COMPONAME, VALUE_NODE, EVA_COMPONAME, VALUE_STRING ));
		addToStringBuffer(getDataOrNodeSchemaXMLStr(EVA_COMPOTYPE, VALUE_NODE, EVA_COMPOTYPE, VALUE_STRING ));
		addToStringBuffer(getDataOrNodeSchemaXMLStr(EVA_ACTION, VALUE_NODE, EVA_ACTION, VALUE_STRING ));
		addToStringBuffer(getDataOrNodeSchemaXMLStr(EVA_LOGTIME, VALUE_NODE, EVA_LOGTIME, VALUE_STRING ));
		
		//FTBDebug(strBuffer);
	}
			

	/**
	 * EXAMPLE OUTPUT:
		<!--- Data Schema for EvaLogger -->
		<KEY ID="screen" FOR="node" ATTR.NAME="screen" ATTR.TYPE="String" />
		<KEY ID="uniqueEvaId" FOR="node" ATTR.NAME="uniqueEvaId" ATTR.TYPE="String" />
		<KEY ID="compoName" FOR="node" ATTR.NAME="compoName" ATTR.TYPE="String" />
		<KEY ID="compoType" FOR="node" ATTR.NAME="compoType" ATTR.TYPE="String" />
		<KEY ID="compoAction" FOR="node" ATTR.NAME="compoAction" ATTR.TYPE="String" />
		<KEY ID="logTime" FOR="node" ATTR.NAME="logTime" ATTR.TYPE="String" />
	 OR instead of node->edge
	 * @param id
	 * @param forWhich
	 * @param name
	 * @param type
	 * @return
	 */
	private String getDataOrNodeSchemaXMLStr( String id, String forWhich, String name, String type ){
		
		String temp = 	"<" + TAG_KEY + " " +
							ATTR_ID + "=\"" + id	+"\" " +
							ATTR_FOR + "=\"" + forWhich	+"\" " +
							ATTR_NAME + "=\"" + name	+"\" " +
							ATTR_TYPE + "=\"" + type	+"\" " +
						"/>";
		
		//FTBDebug(temp);
		
		return temp;
	}
		
	
	/////------------------EDGE SCHEMA------------------------------
	/**
	 * Create EDGE Schema
	  
	  EXAMPLE OUTPUT:
	 	<KEY ID="durationInMillisecs" FOR="edge" ATTR.NAME="durationInMillisecs" ATTR.TYPE="Integer" />
	 	<KEY ID="action" FOR="edge" ATTR.NAME="action" ATTR.TYPE="String" />
	 */
	private void createEdgeSchema(){
		addToStringBuffer("<!--- Edge Schema for EvaLogger -->"); 		
		
		addToStringBuffer(getDataOrNodeSchemaXMLStr(EVA_DURATION_MSECS, VALUE_EDGE, EVA_DURATION_MSECS, VALUE_INT ));
		addToStringBuffer(getDataOrNodeSchemaXMLStr(EVA_ACTION, VALUE_EDGE, EVA_ACTION, VALUE_STRING ));
		
		//FTBDebug(strBuffer);
	}
	
	////////////////My debugging methods////////////////////////////////////////
	/**
	 * My debug messages
	 * @param msg
	 */
	public static void FTBDebug(String msg){
		System.out.println("[FTBDebug]" + msg);
	}

	/**
	 * Lazy printing
	 * @param o
	 */
	public static void p(Object o){
		System.out.print(o);
	}
	
	/**
	 * Lazy printing
	 * @param o
	 */
	public static void pln(Object o){
		System.out.println(o);
	}
	
	///////////////////////////////
	


	
	/********************************************************
	 * A vector containing edges
	 * 
	 */
	class EvaEdgeVector extends Vector{
		
		/**
		 * 
		 * @param source
		 * @param dest
		 * @param action
		 * @param time
		 */
		public void addEdge(String source, String dest, String action, String fromTime, String toTime){
			
			Hashtable <String, String> edgeTable = new Hashtable();
			String uniqueID = makeID(source, dest, fromTime, toTime);
							
			edgeTable.put(EvaGraphML.ATTR_ID, uniqueID);
			
			edgeTable.put(EvaGraphML.ATTR_SOURCE, source);
			edgeTable.put(EvaGraphML.ATTR_TARGET, dest );			
			edgeTable.put(EvaGraphML.EVA_ACTION, action);
			edgeTable.put(EvaGraphML.EVA_DURATION_MSECS, getTimeDurationInMsecs(fromTime, toTime));
						
			//add this edge info to the vector
			add(edgeTable);
		}
		
		/**
		 * 
		 * @return
		 */
		private String getTimeDurationInMsecs(String fromTime, String toTime){
			String duration = "0";			
			long	fromTimeLong = 0;
			long	toTimeLong = 0;
			
			long hourToMsec = 60*60*1000;	 //1 hour X 60 mins x 60 secs x 1000 msecs
			long minsToMsec = 60 * 1000;		//1 min x 60 secs x 1000 msecs
			long secsToMsec = 1000;				//1 secs x 1000 msecs
			
			StringTokenizer tokenizer = new StringTokenizer(fromTime, ":");			
			fromTimeLong = Long.parseLong(tokenizer.nextToken()) * hourToMsec; //hours
			fromTimeLong += Long.parseLong(tokenizer.nextToken()) * minsToMsec;//minutes
			fromTimeLong += Long.parseLong(tokenizer.nextToken())* secsToMsec;//seconds
			
			tokenizer = new StringTokenizer(toTime, ":");
			toTimeLong = Long.parseLong(tokenizer.nextToken()) * hourToMsec; //hours
			toTimeLong += Long.parseLong(tokenizer.nextToken()) * minsToMsec;//minutes
			toTimeLong += Long.parseLong(tokenizer.nextToken())* secsToMsec;//seconds
											
//			FTBDebug("fromTimeLong=" + fromTimeLong );
//			FTBDebug("toTimeLong=" + toTimeLong );
//			FTBDebug("duration = " + (toTimeLong - fromTimeLong));
//			
			duration = Long.toString(toTimeLong - fromTimeLong);
			
			return duration;
		}
		
		/**
		 * This makes an ID, usually unique for each edge
		 * @param source
		 * @param dest
		 * @return
		 */
		private String makeID( String source, String dest, String fromTime, String toTime ){

			StringBuffer theID = new StringBuffer();
			
			theID.append((source.replaceAll(" ", "")));
			theID.append(dest.replaceAll(" ", ""));

			StringTokenizer temp = new StringTokenizer(fromTime, ":");
			while( temp.hasMoreTokens() ){
				theID.append(temp.nextToken());
			}							

			temp = new StringTokenizer(toTime, ":");
			while( temp.hasMoreTokens() ){
				theID.append(temp.nextToken());
			}			
			
			//FTBDebug("EdgeID=" + theID);
			
			return theID.toString();
			
		}		
	}
	
	/********************************************************	 
	 * 	A Vector that contains Hashtables; does not extend the vector class, but my own implementation 
	 * of a vector
	 * 
	 * contains a hashtable<id, hashtable> that contains X hashtable<id, [[node values]]>
	 
	 	EvaScreenVector (n)
	 		|
	 		+------- logVector (1)
	 						|
	 						+------- tableOfNodeValues (n) 	 	 										
	 */	 
	class EvaScreenVector {
		
		private String 	screenSetID;
		private Vector<Hashtable>	logVector; //contains a vector of hashtables <ID, data>
		
		/**
		 * 
		 * @param ID
		 */
		public EvaScreenVector( String ID ){
			this.screenSetID = ID;
			this.logVector = new Vector<Hashtable>();
		}
		
		/**
		 * Get unique ID for this EvaScreenVector
		 * @return
		 */
		public String getId(){			
			return screenSetID;
		}
				
		/**
		 * 
		 * @param location
		 * @return
		 */
		public Hashtable<String, String> getNodeTable(int location){
			
			Hashtable<String, String> tempTable = logVector.get(location);
			
			return tempTable;
		}
		
		
		public Hashtable<String, String> getNode(String uniqueID){
			Hashtable<String, String> tableObj = null;
			
			for( int i=0; i<logVector.size(); i++){
			
				Hashtable<String, String> temp = logVector.get(i);
				if( temp.containsKey(uniqueID) ){
					tableObj = temp;
					break;
				}
			}			
			
			return tableObj;
		}
		
		/**
		 * 
		 * @return
		 */
		public int size(){
			return logVector.size();
		}
		
		/**
		 * 
		 * @param screen
		 * @param compoName
		 * @param compoType
		 * @param action
		 * @param logTime
		 */
		public void addNode(String screen, String compoName, String compoType,
										String action, String logTime){
			
			//FTBDebug(screen + " " + compoName+ " " + compoType+ " " +action+ " " +logTime );
			
			String uniqueID = makeID( screen, compoName, compoType );

			//check if node already exists
			if( !contains(uniqueID) ){
				
				Hashtable <String, String>tempTable = new Hashtable<String, String>();
				
				tempTable.put(EvaGraphML.EVA_UNIQUE_ID, uniqueID);
				tempTable.put(EvaGraphML.EVA_COMPONAME, compoName);
				tempTable.put(EvaGraphML.EVA_COMPOTYPE, compoType );			
				tempTable.put(EvaGraphML.EVA_ACTION, action);
				tempTable.put(EvaGraphML.EVA_LOGTIME, logTime);
				
				logVector.add(tempTable);				
			}
		
		}
		
		
		/**
		 * 
		 * @param uniqueID
		 * @return
		 */
		private boolean contains (String uniqueID){
			boolean hasNode = false;
			
			for( int i=0; i<logVector.size(); i++ ){
			
				Hashtable tempTable = logVector.get(i);
				
				if( tempTable.contains(uniqueID) ){
					hasNode = true;
					break;
				}
			}
			
			return hasNode;
		}				
		
		/**
		 * Create a unique ID base on the parameters.
		 * NOTE: Hopefully there are no components with the same name and type in the same screen
		 * @param screen
		 * @param compoName
		 * @param compoType
		 * @return
		 */
		public String makeID(String screen, String compoName, String compoType){
			
			StringBuffer theID = new StringBuffer();
			
			theID.append((screen.substring(1).replaceAll(" ", "")));
			theID.append(compoName.replaceAll(" ", ""));
			theID.append(compoType.replaceAll(" ", ""));			
			
			return theID.toString();
			
		}
	}
}
