/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * EvaHelperControlCentrer.java
 *
 * Created on Apr 7, 2009, 3:00:47 PM
 */

package evaHelper;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.StringTokenizer;

import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.filechooser.FileFilter;

import evaHelper.images.EvaButtonWithBackground;
import evaHelper.images.EvaPanelWithBackground;
import evaHelper.images.ImageLoader;

/**
 *
 * @author Florence
 */
public class EvaHelperControlCenter extends JFrame {

	private static String	evaHelperSettings	= "evahelper.settings";

	//operating systems
	private static String	macOS = "MAC";
	private static String	winOS = "WINDOWS";	
	private static String	currentOs = macOS;
	
	//paths/locations: get info from user at first start
    private String	sdcardLocation      = null;//"/Users/Florence/mysdcard.img";
    private String	androidToolsPath    = null;//"/Developer/android-sdk-mac_x86-1.1_r1/tools/";//mac
    private String	yedApplicationPath  = null;//"/Applications/yWorks/yEd/";
    
    //commands
    private static String	ddmsCmdMac = "ddms";
    private static String	ddmsCmdWin 	= "ddms.bat";
    private static String	yedMac 			= "yEd.app/Contents/MacOS/JavaApplicationStub";
    private static String	yedWindowPart1	= "java -jar ";	
    private static String	yedWindowPart2	= "yed.jar";	
    
    private  String	runEmulatorCommand= null;	//androidToolsPath + "emulator -sdcard " + sdcardLocation;
    private  String	runDDMSCommand  	= null;	//androidToolsPath + "ddms";
    private  String	runYEDApplication	=null;// yedApplicationPath + "yEd.app/Contents/MacOS/JavaApplicationStub " + (currentOs.contains(macOS)?yedMac:yedWindows);

	//evalogger output
    private String  outputGraphMLFile = null;
    
    //GUI components
    private JTextArea messagesArea;
	private EvaButtonWithBackground runAndroidBtn;
	private EvaButtonWithBackground openDalvikBtn;
	private EvaButtonWithBackground selectLogFileBtn;
	private EvaButtonWithBackground openYedBtn;
   
    /**
     * initialize
     */
    public EvaHelperControlCenter() {
        
    	boolean success = false;
    	File	settingsFile = new File(evaHelperSettings);		
    	
    	try{
    		//set current os
    		currentOs = System.getProperty("os.name").toUpperCase();
    		
    		//FTBDebug(currentOs);
    		//check if settings file exist, if not, make one
    		
    		if( settingsFile.exists() ){
    			BufferedReader reader = new BufferedReader(new FileReader(settingsFile));
    			
    			String temp = null;
    			while((temp = reader.readLine())!=null){
    				
    				//FTBDebug(temp);
    				StringTokenizer token = new StringTokenizer(temp, "=");
    				while(token.hasMoreTokens()){
    					String header = token.nextToken().trim();
    					if( header.equalsIgnoreCase("androidToolsPath")){
    						androidToolsPath = token.nextToken();
    					}
    					else if( header.equalsIgnoreCase("yedApplicationPath")){
    						yedApplicationPath = token.nextToken();
    					}
    					else if( header.equalsIgnoreCase("sdcardLocation")){
    						sdcardLocation = token.nextToken();
    					}
    				}
    			}
    			
    			//FTBDebug("androidToolsPath=" + androidToolsPath);
    			//FTBDebug("yedApplicationPath="+yedApplicationPath);
    			//FTBDebug("sdcardLocation=" + sdcardLocation);
    			
    			if( androidToolsPath != null && yedApplicationPath != null && sdcardLocation !=null ){
    				success = true;
    				initializeCommands();
    			}
    			
    		}
    		else{
    			boolean hasCreated = settingsFile.createNewFile();
    			
    			if( hasCreated ){
    				PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(settingsFile)));
    				
    				File tempFile = openFileChooser("Select Android Tools Path", true);
    				
    				if( tempFile != null ){
    			    	androidToolsPath = tempFile.getAbsolutePath();
    			    	
    			    	FTBDebug(runEmulatorCommand);
    			    
    			    	tempFile = openFileChooser("Select SD card image", false);
        				if( tempFile != null ) {
        					sdcardLocation = tempFile.getAbsolutePath();
        				
        					tempFile = openFileChooser("Select YED application Path", true);
            				if( tempFile != null ) {
            					yedApplicationPath = tempFile.getAbsolutePath();
            					
            					out.println("androidToolsPath=" + androidToolsPath );
            					out.println("sdcardLocation =" + sdcardLocation);
            					out.println("yedApplicationPath =" + yedApplicationPath);
            					
            					initializeCommands();
            					success = true;
            				}//yed
        				}//sdcard
    			    }//androidpath
    				
    				out.close();
    				
    			}
    		}//else
    		
    		//FTBDebug(settingsFile.getAbsolutePath());
    		
    	}
    	catch(Exception e){
    		FTBDebug( e.toString() );
    	}
    	
		if( !success ){
			settingsFile.delete();
			System.exit(0); //terminate program
		}
		else{
			initializeGUI();
			printInMessageArea(androidToolsPath);
			printInMessageArea(sdcardLocation);
			printInMessageArea(yedApplicationPath);
		}
        
    }
    
    /**
     * Initialize commands for buttons 
     */
    private void initializeCommands(){
    	
    	runEmulatorCommand  = androidToolsPath + File.separator+ "emulator -sdcard " + sdcardLocation;    	
    	
    	runDDMSCommand      = androidToolsPath + File.separator +  (currentOs.contains(macOS)?ddmsCmdMac:ddmsCmdWin);    	    	
    	
    	if( currentOs.contains(macOS) ){
    		runYEDApplication	= yedApplicationPath + File.separator + yedMac;
    		FTBDebug(yedApplicationPath);
    		FTBDebug(yedMac);
    		FTBDebug(yedApplicationPath);
    	}
    	else{
    		runYEDApplication = yedWindowPart1 + "\"" + yedApplicationPath + File.separator + yedWindowPart2 +"\"";
    		FTBDebug(runYEDApplication);
    	}

    	//FTBDebug(runEmulatorCommand);
        //FTBDebug(runDDMSCommand);
        FTBDebug(runYEDApplication);
    }
        
    /**
     * initialize gui of main window
     */
    private void initializeGUI(){
    	
    	//-------------Main-----------
    	EvaPanelWithBackground 	mainPanel = new EvaPanelWithBackground(ImageLoader.EvaControlPanelBackground);
    	//mainPanel.setLayout(new BorderLayout());
    	setPreferredSize(mainPanel.getPreferredSize());
    	setSize(mainPanel.getWidth(), mainPanel.getHeight());    	
    	setContentPane(mainPanel);
    	setResizable( false );
    	
    	mainPanel.setLayout(new GridBagLayout());   	
    	GridBagConstraints c = new GridBagConstraints();
    	c.anchor = GridBagConstraints.CENTER;
    	c.insets = new Insets(25,0,0,0); //top, left, bottom, right
    	
    	c.gridx = 1;
    	c.gridy = 1;
    	c.gridheight = 4;
    	c.gridwidth = 2;
    	messagesArea = new JTextArea(22,15); //hxw
    	messagesArea.setEditable(false);
    	messagesArea.setLineWrap(true);
    	messagesArea.setWrapStyleWord(true);//word boundaries wrap
    	
    	JScrollPane scrollPane = new JScrollPane(messagesArea, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);    	
    	mainPanel.add(scrollPane, c);
    	
    	//-------------Buttons-----------
    	 runAndroidBtn = new EvaButtonWithBackground( ImageLoader.RunEmulator, ImageLoader.RunEmulator_selected, ImageLoader.RunEmulator_pressed);
    	 openDalvikBtn = new EvaButtonWithBackground( ImageLoader.OpenDalvik, ImageLoader.OpenDalvik_selected, ImageLoader.OpenDalvik_pressed);
    	 selectLogFileBtn = new EvaButtonWithBackground( ImageLoader.SelectLogFile, ImageLoader.SelectLogFile_selected, ImageLoader.SelectLogFile_pressed);
    	 openYedBtn = new EvaButtonWithBackground( ImageLoader.OpenYed, ImageLoader.OpenYed_selected, ImageLoader.OpenYed_pressed);
    	  
    	//-------------Add Listeners-----
    	runAndroidBtn.addActionListener(new ActionListener() {
    		public void actionPerformed(ActionEvent evt) {
    			runAndroidBtnActionPerformed(evt);
    		}
         });

    	openDalvikBtn.addActionListener(new ActionListener() {
    		public void actionPerformed(ActionEvent evt) {
    			openDalvikBtnActionPerformed(evt);
    		}
         });
    	
    	selectLogFileBtn.addActionListener(new ActionListener() {
    		public void actionPerformed(ActionEvent evt) {
    			selectLogFileBtnActionPerformed(evt);
    		}
         });
    	
    	openYedBtn.addActionListener(new ActionListener() {
    		public void actionPerformed(ActionEvent evt) {
    			openYedBtnActionPerformed(evt);
    		}
         });
    	
    	openYedBtn.setEnabled(false);
    	        	
    	//-------------Add to main panel--
    	c.gridheight = 1;
    	c.gridwidth = 1;
    	
    	c.gridx = 0;
    	c.gridy = 1;
    	mainPanel.add(runAndroidBtn, c);
    	
    	c.insets = new Insets(0,0,0,0); //top, left, bottom, right    	
    	c.gridx = 0;
    	c.gridy = 2;
    	mainPanel.add(openDalvikBtn, c);
    	
    	c.gridx = 0;
    	c.gridy = 3;
    	mainPanel.add(selectLogFileBtn, c);
    	
    	c.gridx = 0;
    	c.gridy = 4;
    	mainPanel.add(openYedBtn, c);    	
    	
    	//-----------Frame related init...
    	setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    	setTitle("EvaHelper");    	
    }
    
    /**
     * Open a file chooser and returns file
     * @return
     */
    private File openFileChooser(String title, boolean directoryOnly){
        
    	File file = null;
 	
    	JFileChooser fileChooser = new JFileChooser();
    	fileChooser.setDialogTitle(title);
    	
    	if( directoryOnly ){
    		fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
    	}
    	
		int returnVal = fileChooser.showOpenDialog(this);
		
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			file = fileChooser.getSelectedFile();
		}

		return file;
    }
    
    /**
     * Open a file chooser and returns file
     * @return
     */
    private static String hackExtension = ""; //fix later
    private File openFileChooser(String title, String extension){
        
    	File file = null;
 	
    	JFileChooser fileChooser = new JFileChooser();
    	fileChooser.setDialogTitle(title);
    	hackExtension = extension;
    	
    	fileChooser.addChoosableFileFilter(new FileFilter(){
    		
    		public boolean accept(File f) {
    			boolean hasValidExt = false;
    			
    	        if (f.isDirectory()) {
    	        	hasValidExt = false;
    	        }
    	       
    	        if( hackExtension.equalsIgnoreCase(getExtension(f)) ){
    	        	hasValidExt = true;
    	        }    	        

    	        //FTBDebug( hackExtension );
    	        //FTBDebug( getExtension(f) );
    	        //FTBDebug( hasValidExt + "" );
    	        
    	        return hasValidExt;
    	    }

    	    //The description of this filter
    	    public String getDescription() {
    	        return "*" + hackExtension ;
    	    }
    	    
    	    public String getExtension(File f) {
    	        String ext = null;
    	        String s = f.getName();
    	        int i = s.lastIndexOf('.');

    	        if (i > 0 &&  i < s.length() - 1) {
    	            ext = s.substring(i+1).toLowerCase();
    	        }
    	        
    	        return "." + ext;
    	    }
    		
    	});
    	
		int returnVal = fileChooser.showOpenDialog(this);
		
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			file = fileChooser.getSelectedFile();
		}

		return file;
    }
    
    /**
     * 
     * @param evt
     */
    private void runAndroidBtnActionPerformed(ActionEvent evt){
    	try{
            String command = runEmulatorCommand;
            runCommand(command);

            printInMessageArea("Running Android Emulator...");
            printInMessageArea("Please be patient, Android takes a bit of time to start up...");
    	}
    	catch(Exception e){
    		FTBDebug( e.toString());
    	}
    }
    
    /**
     * 
     * @param evt
     */
    private void openDalvikBtnActionPerformed(ActionEvent evt){
    	try{
            String command = runDDMSCommand;
            runCommand(command);  
            
            printInMessageArea("Running Dalvik Debugger...");
            printInMessageArea("You can use Dalvik to retrieve files from the device.");
    	}
    	catch(Exception e){
    		FTBDebug( e.toString());
    	}

    }
    /**
     * 
     * @param evt
     */
    private void selectLogFileBtnActionPerformed(ActionEvent evt){
        try{
  	      
        	File file = openFileChooser("Select File", EvaLogger.evaLogExt);
        	
        	if( file != null ){
  	           outputGraphMLFile = file.getAbsolutePath() + ".graphml";
  	            
  	           //printInMessageArea("DEBUG:" + outputGraphMLFile);
  	           printInMessageArea("Opening " + file.getName() + " for conversion...");
  	           
  	           File outFile = EvaWriter.printCSVDataAsGraphMLToFile(file.getAbsolutePath(), outputGraphMLFile);
  	           
  	           if( outFile != null ){
  	        	   outputGraphMLFile = outFile.getAbsolutePath();
  	        	   printInMessageArea("File converted. Output stored in " + outputGraphMLFile);
  	           }
  	           else{
  	        	 printInMessageArea("Conversion Failed.");
  	           }
  	             	         
  	           openYedBtn.setEnabled(true); //only enable this button if a log file is already selected and converted
  	       }
         } 
         catch(Exception e)
         {
  	           FTBDebug("Open command cancelled by user." + "\n");
         }    	
    }
    
    /**
     * 
     * @param evt
     */
    private void openYedBtnActionPerformed(ActionEvent evt){
      try{

			if( outputGraphMLFile != null ){
				String command = "";
				
				if( currentOs.equalsIgnoreCase(macOS)){
					command = runYEDApplication + " " + outputGraphMLFile;
				}
				else{
					command = runYEDApplication + " \"" + outputGraphMLFile +"\"";
				}
				
				runCommand(command);
				
				printInMessageArea("Opening " + outputGraphMLFile + " with YED...");
				FTBDebug(command);
			}
			else{
				FTBDebug("outputGraphMLFile file is null");
			}	   
		} 
	   catch(Exception e)
	   {
	           FTBDebug("Open command cancelled by user." + "\n");
	   }
    }
    
	/**
	 * 
	 * @param msg
	 */
    private void printInMessageArea(String msg){
    	messagesArea.append("\n");
    	messagesArea.append(msg + "\n");
    }
    
    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        new EvaHelperControlCenter().setVisible(true);

    }
    //////////////////////////////////////////////////////////////////////

    /**
     * Run system command
     * @param command
     */
    private void runCommand(String command){
    
        try{

			Process p = Runtime.getRuntime().exec(command);
		}
		catch( Exception e ){
			FTBDebug( e.toString() );
		}
    }
    
    ////////////////My debugging methods
	/**
	 * My debug messages
	 * @param msg
	 */
	public static void FTBDebug(String msg){
		System.out.println("[FTBDebug]" + msg);
	}

	/**
	 * Lazy printing
	 * @param o
	 */
	public static void p(Object o){
		System.out.print(o);
	}

	/**
	 * Lazy printing
	 * @param o
	 */
	public static void pln(Object o){
		System.out.println(o);
	}

}
