/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package evaHelper.images;


import java.awt.Image;
import java.awt.Insets;
import java.awt.image.BufferedImage;
import java.net.URL;
import javax.imageio.ImageIO;
import javax.swing.ImageIcon;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
import javax.swing.JButton;

/**
 *
 * @author florence
 */

public class EvaButtonWithBackground extends JButton{

    private Image  scaledImgNormal = null;
    private Image  scaledImgSelected = null;
    private Image  scaledImgPressed = null;

    public EvaButtonWithBackground(String imgNormal, String imgSelected, String imgPressed){

        // suppress borders
        setBorderPainted ( false );

        // suppress button press decoration
        setContentAreaFilled( false );

        // suppress the ability of the button to be triggered by enter
        setDefaultCapable( false );

        // hide focus rectangle
        setFocusPainted( false );

        // set how wide the space must be around the button. Also use ipadx/ipady
        //setMargin( new Insets ( 10, 10, 10, 10 ));

        // ignore clicks that come too fast
        //setMultiClickThreshhold( 100 /* millis */ );

        // the gifs have transparent background
        setOpaque( false );

        try{
            URL url = getClass().getResource(imgNormal);
            BufferedImage bgImage = ImageIO.read(url);
            scaledImgNormal  = bgImage.getScaledInstance(-1, -1, Image.SCALE_SMOOTH); // width , height as you like, Scalinghint as you like
            setIcon(new ImageIcon(scaledImgNormal));

        }catch( Exception e){
            System.out.println("1 Exception in JButtonWithImageRound:"+e);
        }

        try{
            URL url = getClass().getResource(imgSelected);
            BufferedImage bgImage = ImageIO.read(url);
            scaledImgSelected  = bgImage.getScaledInstance(-1, -1, Image.SCALE_SMOOTH); // width , height as you like, Scalinghint as you like
            setSelectedIcon(new ImageIcon(scaledImgSelected));
            setRolloverIcon(new ImageIcon(scaledImgSelected));
        }catch( Exception e){
            System.out.println("2 Exception in JButtonWithImageRound:"+e);
        }

        try{
            URL
            url = getClass().getResource(imgPressed);
            BufferedImage bgImage = ImageIO.read(url);
            scaledImgPressed  = bgImage.getScaledInstance(-1, -1, Image.SCALE_SMOOTH); // width , height as you like, Scalinghint as you like
            setPressedIcon(new ImageIcon(scaledImgPressed));

        }catch( Exception e){
            System.out.println("3 Exception in JButtonWithImageRound:"+e);
        }
    }

    public EvaButtonWithBackground(String imgNormal, String imgSelected, String imgPressed, String toolTipText){
        this(imgNormal,imgSelected,imgPressed);
        setToolTipText(toolTipText);
    }

    public int getWidth(){
        return scaledImgNormal.getWidth(this);
    }
}


