/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package evaHelper.images;

import java.awt.Image;
import java.awt.image.BufferedImage;
import java.net.URL;
import javax.imageio.ImageIO;

/**
 *  Loads the images for the mobia project and
 *  Contains the links to the images
 * @author florence
 */
public class ImageLoader {
    
    private static String evaImgDir = "/evaHelper/images/";
    
    //Background- FIlenames
    public static String EvaControlPanelBackground    = evaImgDir + "EvaControlCenterDesign.png";

    //Buttons
    public static String OpenYed_pressed    = evaImgDir + "OpenYed_pressed.png";
    public static String OpenYed            = evaImgDir + "OpenYed.png";
    public static String OpenYed_selected   = evaImgDir + "OpenYed_selected.png";

    public static String SelectLogFile_pressed  = evaImgDir + "SelectLogFile_pressed.png";
    public static String SelectLogFile          = evaImgDir + "SelectLogFile.png";
    public static String SelectLogFile_selected          = evaImgDir + "SelectLogFile_selected.png";

    public static String OpenDalvik_pressed     = evaImgDir + "OpenDalvik_pressed.png";
    public static String OpenDalvik         = evaImgDir + "OpenDalvik.png";
    public static String OpenDalvik_selected         = evaImgDir + "OpenDalvik_selected.png";

    public static String RunEmulator_pressed= evaImgDir + "RunEmulator_pressed.png";
    public static String  RunEmulator       = evaImgDir + "RunEmulator.png";
    public static String  RunEmulator_selected       = evaImgDir + "RunEmulator_selected.png";

    /**
     * Returns Image
     * @param filename
     * @return
     */
    public Image getImage(String filename){
        Image temp = null;
        
        try{        
            URL url = getClass().getResource(filename);            
            BufferedImage bgImage = ImageIO.read(url);            
            temp = bgImage.getScaledInstance(-1, -1, Image.SCALE_SMOOTH); //orig size for negative values            
        }
        catch( Exception e){
            FTBDebug("SOME EXCPTION:" + e);
        }         
        
        return temp;
    }
    
    /**
     * Return scaled image
     * @param filename
     * @param width
     * @param height
     * @return
     */
    public Image getScaledImage(String filename, int width, int height){
        Image temp = null;
        
        try{        
            URL url = getClass().getResource(filename);            
            BufferedImage bgImage = ImageIO.read(url);            
            temp = bgImage.getScaledInstance(width, height, Image.SCALE_SMOOTH); //orig size for negative values            
        }
        catch( Exception e){
            FTBDebug("SOME EXCPTION:" + e);
        }         
        
        return temp;
    }
    

    ////////////////My debugging methods
	/**
	 * My debug messages
	 * @param msg
	 */
	public static void FTBDebug(String msg){
		System.out.println("[FTBDebug]" + msg);
	}

	/**
	 * Lazy printing
	 * @param o
	 */
	public static void p(Object o){
		System.out.print(o);
	}

	/**
	 * Lazy printing
	 * @param o
	 */
	public static void pln(Object o){
		System.out.println(o);
	}

}
